open Datatypes

module H = Hashtbl

let int_nat_table = H.create 101

let nat_int_table = H.create 101

let nat_of_int i =
  try 
    H.find int_nat_table i
  with Not_found ->
    let nat =   
      let rec aux i n = 
	if i <= 0 
	then n
	else aux (i-1) (S n)
      in aux i O in
      H.add int_nat_table i nat; nat

let int_of_nat n =
  try 
    H.find nat_int_table n
  with Not_found ->
    let i = 
      let rec aux n i = 
	if i >= max_int then 
	  failwith "error : converting to int a nat  bigger than max_int"
	else
	  match n with 
	    | O -> i
	    | S n -> aux n (i+1)
      in aux n 0 in
      H.add nat_int_table n i; i

let string_of_nat n = "n"^(string_of_int (int_of_nat n))
