(** Various utilities for manipulating lists.*)

Require Import List.

Section Misc.
Set Implicit Arguments.

Variable A :Type.

Definition listProj (P:A->Prop) (l:list (sig P)) : list A :=
  map (proj1_sig (P:=P)) l.

  Definition is_nil (l:list A) :=
    match l with 
      |nil => true
      | _  => false 
    end.


  Lemma is_nil_true : 
    forall (l:list A),
      is_nil l = true -> l = nil.
  Proof.
    unfold is_nil.
    intros l H.
    destruct l. reflexivity.
    discriminate H.
  Qed.
  
  Lemma is_nil_false : 
    forall (l:list A),
      is_nil l = false ->exists a, exists l', l = a::l'.
  Proof.
    unfold is_nil.
    intros  l H.
    destruct l. 
    discriminate H.
    exists a. exists l. reflexivity.
  Qed.
End Misc.